%define zabbix_user	zabbix
%define zabbix_group	zabbix
%define	zabbix_home	/dev/null
%define svnrev 5128

%def_with pgsql

Name: zabbix
Version: 1.4.5
#Release: alt2.svn.%svnrev
Release: alt1

Serial: 1

Summary: A network monitor
License: GPL
Group: System/Servers

Url: http://www.zabbix.com
Packager: Vladimir V Kamarzin <vvk@altlinux.ru>

# http://heanet.dl.sourceforge.net/sourceforge/%name/%name-%version.tar.gz
Source0: %name-%version.tar
Source1: %name.conf
Source2: %{name}_agentd.init
Source3: %{name}_mysql.init
Source4: %{name}_pgsql.init
Source5: %name.migrate.sh
Source6: zabbix_server
Patch0: %name-alt-%version.patch

BuildPreReq: /proc
# Automatically added by buildreq on Wed Dec 05 2007
BuildRequires: libMySQL-devel libiksemel-devel libldap-devel libnet-snmp-devel perl-Switch
# Manually added by vvk
BuildRequires: rsync

%if_with pgsql
BuildRequires: postgresql-devel
%endif

%package common
Summary: %name network monitor (common stuff)
Group: System/Servers

%package server-common
Summary: %name network monitor (server common stuff)
Group: System/Servers
Requires: %name-common = %serial:%version-%release

%package server-mysql
Summary: %name network monitor (server, compiled with MySQL support)
Group: System/Servers
Requires: %name-server-common = %serial:%version-%release
Obsoletes: %name-mysql < 1:1.1.7-alt1

%if_with pgsql
%package server-pgsql
Summary: %name network monitor (server, compiled with PostgreSQL support)
Group: System/Servers
Requires: %name-server-common = %serial:%version-%release
Obsoletes: %name-pgsql < 1:1.1.7-alt1
%endif

%package agent
Summary: %name agent
Group: System/Servers
Requires: %name-common = %serial:%version-%release

%package phpfrontend-engine
Summary: zabbix web frontend (php)
Group: System/Servers
Requires: php-engine
Obsoletes: %name-phpfrontend < 1:1.1.7-alt1

%package phpfrontend-php4
Summary: zabbix web frontend, edition for php4
Group: System/Servers
Requires: php-gd2 php-mysql

%package phpfrontend-php5
Summary: zabbix web frontend, edition for php5
Group: System/Servers
Requires: php5-gd2 php5-mysql

%package phpfrontend-apache
Summary: %name-phpfrontend's apache config files
Group: System/Servers
Requires: %name-phpfrontend-engine = %serial:%version-%release, apache

%package phpfrontend-apache2
Summary: %name-phpfrontend's apache2 config files
Group: System/Servers
Requires: %name-phpfrontend-engine = %serial:%version-%release, apache2

%package doc
Summary: %name network monitor (README, ChangeLog)
Group: System/Servers

%package contrib
Summary: %name network monitor (additional scripts)
Group: System/Servers

%package contrib-agent-win32
Summary: %name network monitor (agent for win32)
Group: System/Servers

%package contrib-agent-win64
Summary: %name network monitor (agent for win64)
Group: System/Servers

%description
ZABBIX is software for monitoring of your applications, network and servers.
ZABBIX supports both polling and trapping techniques to collect data from
monitored hosts. A flexible notification mechanism allows easy and quickly
configure different types of notifications for pre-defined events.

%description common
Common files and docs for zabbix network monitor

ZABBIX is software for monitoring of your applications, network and servers.
ZABBIX supports both polling and trapping techniques to collect data from
monitored hosts. A flexible notification mechanism allows easy and quickly
configure different types of notifications for pre-defined events.

%description server-common
common stuff for zabbix server

%description server-mysql
zabbix server, compiled with MySQL support

ZABBIX is software for monitoring of your applications, network and servers.
ZABBIX supports both polling and trapping techniques to collect data from
monitored hosts. A flexible notification mechanism allows easy and quickly
configure different types of notifications for pre-defined events.

%if_with pgsql
%description server-pgsql
zabbix server, compiled with PostgreSQL support
%endif

%description agent
zabbix network monitor agent.

ZABBIX is software for monitoring of your applications, network and servers.
ZABBIX supports both polling and trapping techniques to collect data from
monitored hosts. A flexible notification mechanism allows easy and quickly
configure different types of notifications for pre-defined events.

%description phpfrontend-apache
zabbix's apache config files

%description phpfrontend-apache2
zabbix's apache2 config files

%description phpfrontend-engine
a php frontend for zabbix - core

%description phpfrontend-php4
zabbix web frontend, edition for php4

%description phpfrontend-php5
zabbix web frontend, edition for php5

%description doc
%name network monitor (README, ChangeLog)

%description contrib
%name network monitor (additional scripts)

%description contrib-agent-win32
%name network monitor (agent for win32)

%description contrib-agent-win64
%name network monitor (agent for win64)

%prep
%setup
%patch0 -p1

%build
autoreconf -fisv

# we must call this for produce dbsync.h
pushd create/schema
./gen.pl c >../../include/dbsync.h
popd

# temporary hack
chmod +x configure

%configure --with-mysql \
	--with-net-snmp \
	--enable-server \
	--enable-agent \
	--with-ldap \
	--with-curl \
	--with-jabber
%make

mv src/%{name}_server/%{name}_server src/%{name}_server/%{name}_mysql
%make clean

%if_with pgsql
%configure --with-pgsql \
	--with-net-snmp \
	--enable-server \
	--enable-agent \
	--with-ldap \
	--with-curl \
	--with-jabber
%make

mv src/%{name}_server/%{name}_server src/%{name}_server/%{name}_pgsql
%endif

# create database schemas
pushd create/schema
%make dist-hook distdir=.
popd

# adjust in several files /home/zabbix
for file in misc/conf/*; do
  sed -i -e "s,/home/zabbix/bin,/usr/sbin,g" \
         -e "s,PidFile=/var/tmp,PidFile=%_var/run/zabbix,g" \
         -e "s,LogFile=/tmp,LogFile=%_logdir/zabbix,g" \
         -e "s,/home/zabbix/lock,%_var/lock/subsys/zabbix,g" \
	 -e "s,/tmp/mysql.sock,%_localstatedir/mysql/mysql.sock,g" $file
done

%install
# create directory structure
install -dm1775 %buildroot%_logdir/%name
install -dm1775 %buildroot%_var/run/%name
install -dm0755 %buildroot%_sbindir
install -dm0750 %buildroot%_sysconfdir/%name
install -dm0755 %buildroot%_var/www/html/addon-modules/%name

# binaries
install -m0755 src/%{name}_*/%{name}_{mysql,get,agentd,sender} %buildroot%_sbindir
%if_with pgsql
install -m0755 src/%{name}_server/%{name}_pgsql %buildroot%_sbindir
%endif

# conf files
install -m0640 misc/conf/%{name}_{server,agentd,trapper}.conf %buildroot%_sysconfdir/%name

# frontends
cp -r frontends %buildroot%_var/www/html/addon-modules/%name/

# apache config
install -pDm0644 %SOURCE1 %buildroot%_sysconfdir/httpd/conf/addon-modules.d/%name.conf

# apache2 config
install -pDm0644 %SOURCE1 %buildroot%_sysconfdir/httpd2/conf/addon.d/A.%name.conf

# start scripts
install -pDm0755 %SOURCE2 %buildroot%_initdir/%{name}_agentd
install -pDm0755 %SOURCE3 %buildroot%_initdir/%{name}_mysql
%if_with pgsql
install -pDm0755 %SOURCE4 %buildroot%_initdir/%{name}_pgsql
%endif
install -pDm0644 %SOURCE6 %buildroot%_sysconfdir/sysconfig/zabbix_server

# migrator
install -m0755 %SOURCE5 migrate.sh

# database upgrades
mkdir tmp-{mysql,postgresql}
rsync -vaP --exclude=postgresql --exclude=oracle upgrades tmp-mysql
rsync -vaP --exclude=mysql --exclude=oracle upgrades tmp-postgresql
mv tmp-mysql/upgrades/dbpatches upgrades-mysql
mv tmp-postgresql/upgrades/dbpatches upgrades-postgresql

%pre common
/usr/sbin/groupadd -r -f %zabbix_group ||:
/usr/sbin/useradd -g %zabbix_group -G proc -c 'Zabbix' \
	-d %zabbix_home -s /dev/null -r %zabbix_user >/dev/null 2>&1 ||:

%post server-mysql
%post_service zabbix_mysql

%preun server-mysql
%preun_service zabbix_mysql

%if_with pgsql
%post server-pgsql
%post_service zabbix_pgsql

%preun server-pgsql
%preun_service zabbix_pgsql
%endif

%post agent
%post_service zabbix_agentd
if [ $1 -eq 1 ]; then
	sed -i -e "s,Hostname=localhost,Hostname=$HOSTNAME,g" \
	%_sysconfdir/%name/%{name}_agentd.conf
fi

%preun agent
%preun_service zabbix_agentd

%post phpfrontend-apache
%_initdir/httpd reload

%postun phpfrontend-apache
%_initdir/httpd reload

%post phpfrontend-apache2
%_initdir/httpd2 reload

%postun phpfrontend-apache2
%_initdir/httpd2 reload

%files common
%dir %attr(1775,root,%zabbix_group) %_logdir/%name
%dir %attr(1775,root,%zabbix_group) %_var/run/%name
%dir %_sysconfdir/%name

%files server-common
%_sbindir/%{name}_get
%config(noreplace) %_sysconfdir/sysconfig/zabbix_server
%config(noreplace) %attr(0640,root,%zabbix_group) %_sysconfdir/%name/%{name}_server.conf
%config(noreplace) %attr(0640,root,%zabbix_group) %_sysconfdir/%name/%{name}_trapper.conf

%files server-mysql
%_sbindir/%{name}_mysql
%_initdir/%{name}_mysql
%doc create/schema/mysql.sql create/data/data.sql create/data/images_mysql.sql
%doc upgrades-mysql

%if_with pgsql
%files server-pgsql
%_sbindir/%{name}_pgsql
%_initdir/%{name}_pgsql
%doc create/schema/postgresql.sql create/data/data.sql create/data/images_pgsql.sql
%doc upgrades-postgresql
%endif

%files agent
%config(noreplace) %attr(0640,root,%zabbix_group) %_sysconfdir/%name/%{name}_agentd.conf
%_initdir/%{name}_agentd
%_sbindir/%{name}_agentd
%_sbindir/%{name}_sender

%files phpfrontend-engine
%_var/www/html/addon-modules/%name/*
%dir %_var/www/html/addon-modules/%name
%exclude %_var/www/html/addon-modules/%name/frontends/php/conf/COPYING

%files phpfrontend-php4

%files phpfrontend-php5

%files phpfrontend-apache
%config(noreplace) %_sysconfdir/httpd/conf/addon-modules.d/%name.conf

%files phpfrontend-apache2
%config(noreplace) %_sysconfdir/httpd2/conf/addon.d/A.%name.conf

%files doc
%doc AUTHORS NEWS README INSTALL docs

%files contrib
%doc misc/snmptrap/* migrate.sh

%files contrib-agent-win32
%doc bin/win32/*

%files contrib-agent-win64
%doc bin/win64/*

%changelog
* Thu Apr 10 2008 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.4.5-alt1
- 1.4.5 release

* Fri Jan 18 2008 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.4.4-alt1
- 1.4.4 release

* Wed Dec 05 2007 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.4.2-alt2.svn.5128
- Security fix: CVE-2007-6210
- Updated to 5128 rev of refs/remotes/1.4

* Tue Aug 21 2007 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.4.2-alt1
- 1.4.2 release
- Implemented sysconfig file for have ability to pass startup arguments to
  zabbix server
- Package docs directory (contains zabbix manual in pdf format)
- Drop some phpfrontend patches, not included by upstream
- Enable jabber support
- Apply two patches from sauron:
  + zabbix-sms.fix - fix infinite waith read loop at zero step in SMS sender
  + zabbix-jabber.fix - fix working with Openfire

* Tue Apr 10 2007 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.1.7-alt1
- 1.1.7
- Split phpfrontend to 3 parts:
  + phpfrontend-engine
  + phpfrontend-php4
  + phpfrontend-php5
- Separate common part of zabix-{my,pg}sql packages to zabix-server-common
- Rename zabix-{my,pg}sql to zabbix-server-{my,pg}sql
- Use %%preun_service, don't %%post_service in %%preun zabbix-server-pgsql
  (bugfix)
- Set Hostname to $HOSTNAME in agentd config after first package install
  (suggested by Konstantin Pavlov <thresh@altlinux>)
- Better drop /proc/XXX-avaibility checks at build-time
- Add russian translation from Andrew Kornilov <hiddenman@altlinux>
- Add phpfrontend-apache2 subpackage
- Switch to use .gear-tags

* Mon Feb 19 2007 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.1.6-alt1
- 1.1.6

* Tue Jan 30 2007 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.1.5-alt1
- 1.1.5

* Fri Jan 12 2007 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.1.4-alt3
- Added some useful patches:
  + Create trigger button on item form, see
  http://www.zabbix.com/forum/showthread.php?t=4858
  + Add Hostname Colum To Trigger Status Page, see
  http://www.zabbix.com/forum/showthread.php?t=4912
  + Add hyperlinks to the Monitoring/Overview page
    + secondary sort by hosts (the primary sort order is still by trigger, but
    hosts with the same triggers are sorted alphabetically now)
    + clicking on one of the (vertical) hostnames will take you to the latest data
    obtained from this host
    + clicking on a (green or red) field in the matrix will take you to the
    simple graph of this data item
  see http://www.zabbix.com/forum/showthread.php?t=4105
  + Variable {ITEM.NAME} for alert messages, see
  http://www.zabbix.com/forum/showthread.php?t=4806

* Wed Dec 13 2006 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.1.4-alt2
- Reworked subpackaging schema (Closes: #10400):
  + Move .sql-files for MySQL into %name-mysql package
  + Move .sql-files for PostgreSQL into %name-pgsql package
  + Move contrib-scripts into %name-contrib
  + Move win32 agent into %name-contrib-agent-win32
  + Move win64 agent into %name-contrib-agent-win64
- Integrate these patches into source-tree:
  + zabbix-1.1.1-alt-config.h.chroot_build.patch
  + zabbix-1.1.2-alt-daemon.patch
  + zabbix-1.1.2-alt-diskio.c_kernelcheck.patch
  + zabbix-1.1beta9-alt-check_alive_zabbix_mysql.patch
- Temporary remove dependency on php-gd2 because of bug #10401, be close,
  don't forget to install php-gd2/php5-gd2 by hand
- Rebuild with new libnetsnmp

* Wed Nov 15 2006 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.1.4-alt1
- 1.1.4
- Removed zabbix-1.1.3-deb-delta.patch (merged upstream)
- Enabled PostgreSQL support

* Mon Nov 13 2006 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.1.3-alt1
- 1.1.3
- Removed patches (merged upstream)
  + zabbix-1.1.2-deb-security.patch
  + zabbix-1.1.2-deb-expression.c.patch
  + zabbix-1.1.2-deb-maps.inc.php.patch
  + zabbix-1.1.2-deb-data.sql.patch
- Fix delta problem, see: http://www.zabbix.com/forum/showthread.php?t=4315
  (patch from Debian, zabbix-1.1.3-deb-delta.patch)
- Removed warning-message about "need database upgrade"
- Enhanced initscript of zabbix_agentd also (stale pidfile removing)

* Tue Oct 10 2006 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.1.2-alt3
- Added zabbix-1.1.2-deb-security.patch for fix security issues discovered by
  the debian-audit project (Debian bug #391388) (Secunia Advisory 22313)
- Added zabbix-1.1.2-deb-expression.c.patch for fix substitution of variables
  in action e-mails, see: http://www.zabbix.com/forum/showthread.php?t=3969
- Added zabbix-1.1.2-deb-maps.inc.php.patch for fix reversed icons issue, see:
  http://www.zabbix.com/forum/showthread.php?t=3986
  http://www.zabbix.com/forum/showthread.php?t=3979
- Added zabbix-1.1.2-deb-data.sql.patch for fix login problem if
  http://localhost/ is used, see
  http://www.zabbix.com/forum/showthread.php?t=4033

* Tue Oct 03 2006 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.1.2-alt2
- Added zabbix-1.1.2-alt-daemon.patch for fix handling of file descriptors
  (suggested by hiddenman@)

* Thu Sep 21 2006 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.1.2-alt1
- 1.1.2
- zabbix-1.1beta7-alt-diskio.c_kernelcheck.patch rediffed and renamed to
  zabbix-1.1.2-alt-diskio.c_kernelcheck.patch

* Mon Jul 24 2006 Vladimir V Kamarzin <vvk@altlinux.ru> 1:1.1.1-alt1
- 1.1.1 release
- Added Serial tag
- Added again zabbix-1.1.1-alt-config.h.chroot_build.patch for disable some
  checks at build-time
- Improved server initscript - added autoremoving of stale pidfile

* Tue Jun 06 2006 Vladimir V Kamarzin <vvk@altlinux.ru> 1.1rel-alt1
- 1.1 release

* Thu May 04 2006 Vladimir V Kamarzin <vvk@altlinux.ru> 1.1beta9-alt3
- useradd,groupadd actions moved to %%pre common (reported by hiddenman@)

* Thu Apr 27 2006 Vladimir V Kamarzin <vvk@altlinux.ru> 1.1beta9-alt2
- Add zabbix-1.1beta9-alt-check_alive_zabbix_mysql.patch for fix wrong name of
  zabbix daemon in phpfrontend (reported by hiddenman@)
- In apache's config AllowOverride directive has been changed from "None" to
  "AuthConfig Limit" (FR by hiddenman@)

* Wed Apr 26 2006 Vladimir V Kamarzin <vvk@altlinux.ru> 1.1beta9-alt1
- new version (1.1beta9)

* Mon Apr 17 2006 Vladimir V Kamarzin <vvk@altlinux.ru> 1.1beta8-alt2
- Add migrate.sh script

* Tue Apr 04 2006 Vladimir V Kamarzin <vvk@altlinux.ru> 1.1beta8-alt1
- Beta 8
- Removed unneeded README.ALT.1
- Added zabbix-1.1beta7-alt-diskio.c_kernelcheck.patch for realtime checking
  of kernel version instead of compilation time
- SQL-data moved to -doc subpackage
- Updated Summary and Description
- Removed zabbix-config.h.in.chroot.patch
- Added /proc to BuildPreReq
- Corrected Requires of subpackages
- Do not use some macroses in spec anymore (%%__install, %%__mv)
- Add zabbix pseudouser to 'proc' group

* Fri Dec 02 2005 ALT QA Team Robot <qa-robot@altlinux.org> 1.1beta2-alt2.1
- rebuild with libnetsnmp.so.9

* Tue Nov 22 2005 Vladimir V Kamarzin <vvk@altlinux.ru> 1.1beta2-alt2
- Added missing requires for phpfrontend (php-engine, php-gd2)
- File db.inc.php now packaged as %%config(noreplace) (thanks to hiddenman@ :)
  )
- Package %name-phpfrontend splitted (Closes #8324)
- Changed permissions of /var/log/zabbix/ and /var/run/zabbix due to ALT
  security policy
- Corrected default path to mysql.sock
- Common stuff moved to -common package
- Added zabbix-config.h.in.chroot.patch for disabling some checks in chroot
  (thanks to lakostis@)
- Updated create/data/README.ALT
- Minor spec update

* Wed Oct 19 2005 Vladimir V Kamarzin <vvk@altlinux.ru> 1.1beta2-alt1
- New version.
- PostgreSQL support still disabled.
- Packaged zabbix_get utility.

* Wed Sep 21 2005 Vladimir V Kamarzin <vvk@altlinux.ru> 1.1beta1-alt1
- New version.
- PostgreSQL support temporary disabled.
- Removed COPYING from package.
- Packaged snmptrap.sh script and agent W32binary.
- Added README.ALT to /usr/share/doc/.../create/data
- fixed package ownership of /etc/%name
- changed permissions of config-files.

* Sat Sep 03 2005 Vladimir V Kamarzin <vvk@altlinux.ru> 1.1alpha10-alt1
- Initial build for Sisyphus.
